<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">

<!--
Copyright 2007, Google Inc.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
    this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. Neither the name of Google Inc. nor the names of its contributors may be
    used to endorse or promote products derived from this software without
    specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->

<html>
  <head>
    <title>Desktop API</title>
    <link rel="stylesheet" type="text/css" href="gears.css" />
  </head>

<body>

<h1>Desktop API</h1>

<div id="pagecontent">

<p>The Desktop module provides an interface for accessing desktop related
functionality, such as creating shortcuts.

<h2 id="example">Example</h2>

<pre><code>&lt;script type="text/javascript" src="<a href=
  'tools.html#gears_init'>gears_init.js</a>"&gt;&lt;/script&gt;
&lt;script type="text/javascript"&gt;
var desktop = google.gears.factory.create('beta.desktop');
desktop.createShortcut("Test Application",
                       "An application at http://example.com/index.html",
                       "http://example.com/index.html",
                       {"128x128": "http://example.com/icon128x128.png",
                        "48x48": "http://example.com/icon48x48.png",
                        "32x32": "http://example.com/icon32x32.png",
                        "16x16": "http://example.com/icon16x16.png"});
&lt;/script&gt;</code></pre>


<h2 id="classes">Classes</h2>

<pre><code><a href="#Desktop">Desktop class</a>
    bool <b>createShortcut</b>(name, description, url, icons)
</code></pre>
<br>


<br>
<a name="Desktop"></a>
<h2>Desktop class</h2>

<h3>Methods</h3>

<table>
  <tr class="odd">
    <th colspan="2"><code>createShortcut(name, description, url, icons)</code></th>
  </tr>
  <tr class="odd">
    <td width="113">Summary:</td>
    <td width="550" class="odd">
      Creates a desktop shortcut for launching a web application.
    </td>
  </tr>
  <tr class="odd">
    <td>Parameters:</td>
    <td class="odd">
      <code>name</code> - The user-visible name of the shortcut. It cannot contain any of these characters:
        <code>"\/:*?&lt;&gt;|</code>
      <br>
      <code>description</code> - Additional text to display in the
        confirmation dialog.
      <br>
      <code>url</code> - The address to launch when the user opens the shortcut.
      <br>
      <code>icons</code> - An object containing one or more of these named
        properties: <code>128x128</code>, <code>48x48</code>,
        <code>32x32</code>, <code>16x16</code>.  The value of each property must
        be the URL of a .png file, with dimensions matching the property name.
      </td>
  </tr>
  <tr class="odd">
    <td>Details:</td>
    <td class="odd">
      The icon sizes were chosen to meet the needs of a variety of platforms.
      If an application wants its icons to look as good as possible on all
      platforms, it should provide all valid sizes.
      <br><br>
      Only one desktop shortcut can exist for any particular name.
      <br><br>
      The shortcut will launch the same web browser that created the shortcut.
      <br><br>
      The <code>url</code> and <code>icons</code> values can be relative or
      absolute URLs.  Relative URLs are resolved using the caller's location.
      <br><br>
      Calling this API will trigger a confirmation dialog.  The dialog will
      use the 32x32 icon if it exists, or else the closest size available.
    </td>
  </tr>
</table>


</div>
</body>
</html>
